unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OmegaTimer, OmegaFont, OmegaInput, OmegaImageList, OmegaScreen,
  OmegaSprite;

type
  TGracz=class(TSprite)
  private
    Zycie0,           //poczatkowy stan zycia
    Zycie :single;    //realny stan zycia
    fPokaz:boolean;   //flaga poka/ ukryj pasek zycia
    procedure RysujPasekZycia;
    procedure Draw;override;
    procedure Dead;override;
  protected
    constructor Create(const AParent: TOmegaSprite;
                       const ImageListItem: TImageListItem;//indeks obrazu z listy OmegaImageList
                       const IdKlatka:Integer;//indeks wycinanej klatki
                       const PKTZycie:single//punkty zycia
                       );virtual;
  end;

  TForm1 = class(TForm)
    OmegaScreen1: TOmegaScreen;
    OmegaImageList1: TOmegaImageList;
    OmegaInput1: TOmegaInput;
    OmegaFont1: TOmegaFont;
    OmegaTimer1: TOmegaTimer;
    OmegaSprite1: TOmegaSprite;
    procedure OmegaTimer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
//*******BLOK KLASY GRACZ*******************************
procedure TGracz.RysujPasekZycia;
var
 dx:integer;
begin
 //przechwy wcisnicie klawisza "I"
 if oisbutton2 in Form1.OmegaInput1.keyboard.statesclicked then
 fPokaz:=not fPokaz;
 if not fPokaz then exit;
 //rozpocznij proces rysowania paskow zycia
 //normuj do dugosci 32 pikseli
 dx:=round(Zycie*32/Zycie0);
 //czerwona linia
 Form1.OmegaScreen1.LineH(Round(x+dx),Round(x+32),Round(y),200,0,0,2);
 //zielona linia
 Form1.OmegaScreen1.LineH(Round(x),Round(x+dx),Round(y),0,125,0,2);
end;

procedure TGracz.Draw;
begin
 inherited Draw;
 RysujPasekZycia;
end;
procedure TGracz.Dead;
begin
  inherited Dead;
  //umier duszka jesli jego zycie osignie 0 PKT
  if Zycie<=0 then Dead;
end;
constructor TGracz.Create(const AParent: TOmegaSprite;
                          const ImageListItem: TImageListItem;//indeks obrazu z listy OmegaImageList
                          const IdKlatka:Integer;//indeks wycinanej klatki
                          const PKTZycie:single//punkty zycia
                          );
begin
 inherited Create(AParent);
 Image := ImageListItem;
 ImageIndex:=idKlatka;
 width:=Image.TileWidth;
 height:=Image.TileHeight;
 x:=Random(700);
 y:=Random(500);
 //zapaietaj max ilosc punktw ycia
 Zycie0:=PKTZycie;
 //Przykladowo ustal losowa wartosc punktow zycia
 Zycie :=Round(PKTZycie-Random(Round(PKTZycie)));
 fPokaz:=true;
end;
//********KONIEC BLOKU KLASY GRACZ*********************
procedure TForm1.OmegaTimer1Timer(Sender: TObject);
begin
 OmegaInput1.Update;
 if oisbutton1 in OmegaInput1.keyboard.statesclicked then
  OmegaScreen1.ToggleFullScreen;
 if not omegascreen1.CanDraw then exit;
 OmegaScreen1.ClearScreen(0,0,0,0);
 OmegaScreen1.BeginRender;

 OmegaSprite1.Dead;
 OmegaSprite1.Move(OmegaTimer1.DeltaSecs);
 OmegaSprite1.Draw;

 OmegaFont1.Print(0,20,'F2 zmiana trybu wywietlania aplikacji');
 OmegaFont1.Print(0,40,'FPS: '+IntToStr(OmegaTimer1.FPS));

 OmegaScreen1.EndRender;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  OmegaScreen1.Init;
  OmegaScreen1.SetHWnd(self.handle);
  OmegaFont1.Init;
  OmegaFont1.CreateFont('Arial',10,[]);
  OmegaFont1.Color:=OmegaColor(0,200,0);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  OmegaTimer1.Enabled:=false;
  OmegaSprite1.Dead;
  OmegaScreen1.FreeOnRelease;
  if OmegaScreen1.FullScreen then  OmegaScreen1.ToggleFullScreen;
end;

procedure TForm1.FormShow(Sender: TObject);
const
 klatka  :array[0..3]of byte  =(24,27,30,33);   //indeksy wycinanych klatek bohaterw
 PKTZycie:array[0..3]of single=(100,200,150,50);//tablica przykladowych wartosci punktw ycia
var
 i:integer;
begin
 RAndomize;
 for i:=0 to 9 do
 TGracz.Create(OmegaSprite1,OmegaImageList1.ImageList.Items[0],
                            klatka[Random(high(klatka))],//losuj indeks wycinanej klatki
                            PKTZycie[Random(high(PKTZycie))]);//losuj max pkt zycia
 OmegaTimer1.Enabled:=true;
end;

end.
